<template>
  <div
    class="ui modal"
    id="new-meal-modal"
  >
    <i class="close icon"></i>
    <div class="header">
      Ajouter un nouveau repas
    </div>
    <div class="content">
      <form
        class="ui form"
        @submit.prevent="submit"
      >
        <div class="fields">
          <div class="twelve wide required field">
            <label>Menu</label>
            <dropdown-menus
              @menuChanged="updateMenu"
            >
            </dropdown-menus>
          </div>
        </div>
        <div class="fields">
          <div class="six wide required field">
            <label>Période</label>
            <radio-period
              :period="period"
              @updatePeriod="updatePeriod"
            ></radio-period>
          </div>
          <div class="six wide required field">
            <label>Date</label>
            <input
              type="text"
              v-model="date"
              placeholder="Date"
            >
          </div>
        </div>
      </form>
    </div>
    <div class="actions">
      <div
        class="ui toggle checkbox"
        @click="toggleAddAnother"
      >
        <input
          name="addAnother"
          type="checkbox"
          class="hidden"
          tabindex="0"
          :checked="addAnother"
        >
        <label>Ajouter un autre ensuite</label>
      </div>

      <div
        class="ui red basic button"
        @click="cancel"
      >Anuler</div>

      <div
        class="ui primary button"
        :class="loading ? 'loading disabled' : ''"
        @click="submit"
      >OK</div>
    </div>
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'

import DropdownMenus from '@/components/menus/DropdownMenus'
import RadioPeriod from './RadioPeriod'

import store from '@/store/Store'

export default {
  name: 'ModalNewPatient',
  store,
  data () {
    return {
      addAnother: false,
      menu: null,
      period: 'LUNCH',
      date: ''
    }
  },
  mounted () {
    // eslint-disable-next-line
    $('#new-meal-modal')
      .modal('setting', 'transition', 'scale')
  },
  methods: {
    ...mapActions({
      addMeal: 'MealsStore/addMeal'
    }),
    toggleAddAnother () {
      this.addAnother = !this.addAnother
    },
    updateMenu (id) {
      this.menu = id
    },
    updatePeriod (period) {
      this.period = period
    },
    cancel () {
      // eslint-disable-next-line
      $('#new-meal-modal')
        .modal('hide')
    },
    submit () {
      var self = this

      let meal = {
        period: this.period
      }

      if (this.date !== '') {
        meal.date = new Date(this.date)
      }
      if (this.menu !== null && this.menu !== '') {
        meal.menu = { _id: this.menu }
      }

      this.addMeal(meal)
        .then((response) => {
          this.$toastr.s('Bien ajouté')
          if (!self.addAnother) {
            // eslint-disable-next-line
            $('#new-meal-modal')
              .modal('hide')
          }
          this.emptyModal()
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        })
    },
    emptyModal () {
      // vider les champs
      this.dishes = ''
    }
  },
  computed: {
    ...mapGetters({
      loading: 'loading'
    })
  },
  components: {
    DropdownMenus,
    RadioPeriod
  }
}
</script>
